Enabled parallelisation of Adaptive stream encoding. See HLS-6
Enabled parallelisation of Adaptive stream encoding. See HLS-6

#!/bin/bash #!/bin/bash
# #
# A very simple BASH script to take an input video and split it down into Segments # A very simple BASH script to take an input video and split it down into Segments
# before creating an M3U8 Playlist, allowing the file to be served using HLS # before creating an M3U8 Playlist, allowing the file to be served using HLS
# #
# #
   
###################################################################################### ######################################################################################
# #
# Copyright (c) 2013, Ben Tasker # Copyright (c) 2013, Ben Tasker
# All rights reserved. # All rights reserved.
# #
# Redistribution and use in source and binary forms, with or without modification, # Redistribution and use in source and binary forms, with or without modification,
# are permitted provided that the following conditions are met: # are permitted provided that the following conditions are met:
# #
# Redistributions of source code must retain the above copyright notice, this # Redistributions of source code must retain the above copyright notice, this
# list of conditions and the following disclaimer. # list of conditions and the following disclaimer.
# #
# Redistributions in binary form must reproduce the above copyright notice, this # Redistributions in binary form must reproduce the above copyright notice, this
# list of conditions and the following disclaimer in the documentation and/or # list of conditions and the following disclaimer in the documentation and/or
# other materials provided with the distribution. # other materials provided with the distribution.
# #
# Neither the name of Ben Tasker nor the names of his # Neither the name of Ben Tasker nor the names of his
# contributors may be used to endorse or promote products derived from # contributors may be used to endorse or promote products derived from
# this software without specific prior written permission. # this software without specific prior written permission.
# #
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND # THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED # ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE # WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR # DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
# ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES # ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; # (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON # LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
# ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT # ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS # (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. # SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# #
###################################################################################### ######################################################################################
   
# Basic config # Basic config
OUTPUT_DIRECTORY=${OUTPUT_DIRECTORY:-'./output'} OUTPUT_DIRECTORY=${OUTPUT_DIRECTORY:-'./output'}
   
# Change this if you want to specify a path to use a specific version of FFMPeg # Change this if you want to specify a path to use a specific version of FFMPeg
FFMPEG=${FFMPEG:-'ffmpeg'} FFMPEG=${FFMPEG:-'ffmpeg'}
   
# Number of threads which will be used for transcoding. With newer FFMPEGs and x264 # Number of threads which will be used for transcoding. With newer FFMPEGs and x264
# encoders "0" means "optimal". This is normally the number of CPU cores. # encoders "0" means "optimal". This is normally the number of CPU cores.
NUMTHREADS=${NUMTHREADS:-"0"} NUMTHREADS=${NUMTHREADS:-"0"}
   
# Video codec for the output video. Will be used as an value for the -vcodec argument # Video codec for the output video. Will be used as an value for the -vcodec argument
VIDEO_CODEC=${VIDEO_CODEC:-"libx264"} VIDEO_CODEC=${VIDEO_CODEC:-"libx264"}
   
# Video codec for the output video. Will be used as an value for the -acodec argument # Video codec for the output video. Will be used as an value for the -acodec argument
AUDIO_CODEC=${AUDIO_CODEC:-"libfdk_aac"} AUDIO_CODEC=${AUDIO_CODEC:-"libfdk_aac"}
   
# Additional flags for ffmpeg # Additional flags for ffmpeg
FFMPEG_FLAGS=${FFMPEG_FLAGS:-""} FFMPEG_FLAGS=${FFMPEG_FLAGS:-""}
   
  # If the input is a live stream (i.e. linear video) this should be 1
  LIVE_STREAM=${LIVE_STREAM:-0}
   
  # Video bitrates to use in output (comma seperated list if you want to create an adaptive stream.)
  # leave null to use the input bitrate
  OP_BITRATES=${OP_BITRATES:-''}
   
  # Determines whether the processing for adaptive streams should run sequentially or not
  NO_FORK=${NO_FORK:-0}
   
# Lets put our functions here # Lets put our functions here
   
   
## Output the script's CLI Usage ## Output the script's CLI Usage
# #
# #
function print_usage(){ function print_usage(){
   
cat << EOM cat << EOM
HTTP Live Stream Creator HTTP Live Stream Creator
Version 1 Version 1
   
Copyright (C) 2013 B Tasker, D Atanasov Copyright (C) 2013 B Tasker, D Atanasov
Released under BSD 3 Clause License Released under BSD 3 Clause License
See LICENSE See LICENSE
   
   
Usage: HLS-Stream-Creator.sh -i [inputfile] -s [segmentlength(seconds)] -o [outputdir] Usage: HLS-Stream-Creator.sh -[lf] [-c segmentcount] -i [inputfile] -s [segmentlength(seconds)] -o [outputdir] -b [bitrates]
   
-i Input file -i Input file
-s Segment length (seconds) -s Segment length (seconds)
-o Output directory (default: ./output) -o Output directory (default: ./output)
  -l Input is a live stream
  -c Number of segments to include in playlist (live streams only) - 0 is no limit
  -b Output video Bitrates (comma seperated list for adaptive streams)
  -f Foreground encoding only (don't fork the encoding processes into the background - adaptive non-live streams only)
   
Deprecated Legacy usage: Deprecated Legacy usage:
HLS-Stream-Creator.sh inputfile segmentlength(seconds) [outputdir='./output'] HLS-Stream-Creator.sh inputfile segmentlength(seconds) [outputdir='./output']
   
EOM EOM
   
exit exit
   
} }
   
   
  function createStream(){
  # For VoD and single bitrate streams the variables we need will exist in Global scope.
  # for live adaptive streams though, that won't be the case, so we need to take them as arguments
  # Some are global though, so we'll leave those as is
   
  playlist_name="$1"
  output_name="$2"
  bitrate="$3"
   
  $FFMPEG -i "$INPUTFILE" \
  -loglevel error -y \
  -vcodec "$VIDEO_CODEC" \
  -acodec "$AUDIO_CODEC" \
  -threads "$NUMTHREADS" \
  -map 0 \
  -flags \
  -global_header \
  -f segment \
  -segment_list "$playlist_name" \
  -segment_time "$SEGLENGTH" \
  -segment_format mpeg_ts \
  $bitrate \
  $FFMPEG_ADDITIONAL \
  $FFMPEG_FLAGS \
  "$OUTPUT_DIRECTORY/$output_name"
  }
   
   
  function createVariantPlaylist(){
  playlist_name="$1"
  echo "#EXTM3U" > "$playlist_name"
  }
   
   
  function appendVariantPlaylistentry(){
  playlist_name=$1
  playlist_path=$2
  playlist_bw=$(( $3 * 1000 )) # bits not bytes :)
   
  cat << EOM >> "$playlist_name"
  #EXT-X-STREAM-INF:BANDWIDTH=$playlist_bw
  $playlist_path
  EOM
   
  }
   
   
  function awaitCompletion(){
  # Monitor the encoding pids for their completion status
  while [ ${#PIDS[@]} -ne 0 ]; do
  # Calculate the length of the array
  pid_length=$((${#PIDS[@]} - 1))
   
  # Check each PID in the array
  for i in `seq 0 $pid_length`
  do
  # Test whether the pid is still active
  if ! kill -0 ${PIDS[$i]} 2> /dev/null
  then
  echo "Encoding for bitrate ${BITRATE_PROCESSES[$i]}k completed"
  unset BITRATE_PROCESSES[$i]
  unset PIDS[$i]
  fi
  done
  PIDS=("${PIDS[@]}") # remove any nulls
  sleep 1
  done
  }
   
   
  # This is used internally, if the user wants to specify their own flags they should be
  # setting FFMPEG_FLAGS
  FFMPEG_ADDITIONAL=''
  LIVE_SEGMENT_COUNT=0
   
# Get the input data # Get the input data
   
# This exists to maintain b/c # This exists to maintain b/c
LEGACY_ARGS=1 LEGACY_ARGS=1
   
# If even one argument is supplied, switch off legacy argument style # If even one argument is supplied, switch off legacy argument style
while getopts "i:o:s:" flag while getopts "i:o:s:c:b:lf" flag
do do
  LEGACY_ARGS=0
case "$flag" in case "$flag" in
i) LEGACY_ARGS=0; INPUTFILE="$OPTARG";; i) INPUTFILE="$OPTARG";;
o) LEGACY_ARGS=0; OUTPUT_DIRECTORY="$OPTARG";; o) OUTPUT_DIRECTORY="$OPTARG";;
s) LEGACY_ARGS=0; SEGLENGTH="$OPTARG";; s) SEGLENGTH="$OPTARG";;
  l) LIVE_STREAM=1;;
  c) LIVE_SEGMENT_COUNT="$OPTARG";;
  b) OP_BITRATES="$OPTARG";;
  f) NO_FORK=1;;
esac esac
done done
   
   
if [ "$LEGACY_ARGS" == "1" ] if [ "$LEGACY_ARGS" == "1" ]
then then
# Old Basic Usage is # Old Basic Usage is
# cmd.sh inputfile segmentlength # cmd.sh inputfile segmentlength
   
INPUTFILE=${INPUTFILE:-$1} INPUTFILE=${INPUTFILE:-$1}
SEGLENGTH=${SEGLENGTH:-$2} SEGLENGTH=${SEGLENGTH:-$2}
if ! [ -z "$3" ] if ! [ -z "$3" ]
then then
OUTPUT_DIRECTORY=$3 OUTPUT_DIRECTORY=$3
fi fi
fi fi
   
   
# Check we've got the arguments we need # Check we've got the arguments we need
if [ "$INPUTFILE" == "" ] || [ "$SEGLENGTH" == "" ] if [ "$INPUTFILE" == "" ] || [ "$SEGLENGTH" == "" ]
then then
print_usage print_usage
fi fi
   
# FFMpeg is a pre-requisite, so let check for it # FFMpeg is a pre-requisite, so let check for it
if hash $FFMPEG 2> /dev/null if hash $FFMPEG 2> /dev/null
then then
# FFMpeg exists # FFMpeg exists
echo "ffmpeg command found.... continuing" echo "ffmpeg command found.... continuing"
else else
# FFMPeg doesn't exist, uh-oh! # FFMPeg doesn't exist, uh-oh!
echo "Error: FFmpeg doesn't appear to exist in your PATH. Please addresss and try again" echo "Error: FFmpeg doesn't appear to exist in your PATH. Please addresss and try again"
exit 1 exit 1
fi fi
   
   
# Now we want to make sure out input file actually exists # Now we want to make sure out input file actually exists
  # This will need tweaking in future if we want to allow a RTMP stream (for example) to be used as input
if ! [ -f "$INPUTFILE" ] if ! [ -f "$INPUTFILE" ]
then then
echo "Error: You gave me an incorrect filename. Please re-run specifying something that actually exists!" echo "Error: You gave me an incorrect filename. Please re-run specifying something that actually exists!"
exit 1 exit 1
fi fi
   
# Check output directory exists otherwise create it # Check output directory exists otherwise create it
if [ ! -w $OUTPUT_DIRECTORY ] if [ ! -w $OUTPUT_DIRECTORY ]
then then
echo "Creating $OUTPUT_DIRECTORY" echo "Creating $OUTPUT_DIRECTORY"
mkdir -p $OUTPUT_DIRECTORY mkdir -p $OUTPUT_DIRECTORY
fi fi
   
  if [ "$LIVE_STREAM" == "1" ]
  then
  FFMPEG_ADDITIONAL+="-segment_list_flags +live"
   
  if [ "$LIVE_SEGMENT_COUNT" -gt 0 ]
  then
  FFMPEG_ADDITIONAL+=" -segment_list_size $LIVE_SEGMENT_COUNT"
  fi
  fi
   
   
# Pulls file name from INPUTFILE which may be an absolute or relative path. # Pulls file name from INPUTFILE which may be an absolute or relative path.
INPUTFILENAME=${INPUTFILE##*/} INPUTFILENAME=${INPUTFILE##*/}
   
# Finally, lets build the output filename format # Will look at making this configurable later
OUT_NAME=$INPUTFILENAME"_%05d.ts" PLAYLIST_PREFIX=$INPUTFILENAME
   
# Processing Starts  
$FFMPEG -i "$INPUTFILE" \ # Set the bitrate
-loglevel error -y \ if [ ! "$OP_BITRATES" == "" ]
-vcodec "$VIDEO_CODEC" \ then
-acodec "$AUDIO_CODEC" \ # Make the bitrate list easier to parse
-threads "$NUMTHREADS" \ OP_BITRATES=${OP_BITRATES//,/$'\n'}
-map 0 \  
-flags \ # Create an array to house the pids for backgrounded tasks
-global_header \ declare -a PIDS
-f segment \ declare -a BITRATE_PROCESSES
-segment_list "$OUTPUT_DIRECTORY/$INPUTFILENAME.m3u8" \  
-segment_time "$SEGLENGTH" \ # Get the variant playlist created
-segment_format mpeg_ts \ createVariantPlaylist "$OUTPUT_DIRECTORY/${PLAYLIST_PREFIX}_master.m3u8"
$FFMPEG_FLAGS \ for br in $OP_BITRATES
$OUTPUT_DIRECTORY/"$OUT_NAME" || exit 1 do
  appendVariantPlaylistentry "$OUTPUT_DIRECTORY/${PLAYLIST_PREFIX}_master.m3u8" "${PLAYLIST_PREFIX}_${br}.m3u8" "$br"
  done
   
  # Now for the longer running bit, transcode the video
  for br in $OP_BITRATES
  do
  BITRATE="-b:v ${br}k -bufsize ${br}k"
  # Finally, lets build the output filename format
  OUT_NAME="${INPUTFILENAME}_${br}_%05d.ts"
  PLAYLIST_NAME="$OUTPUT_DIRECTORY/${PLAYLIST_PREFIX}_${br}.m3u8"
   
  echo "Generating HLS segments for bitrate ${br}k - this may take some time"
   
  if [ "$NO_FORK" == "0" ] && [ ! "$LIVE_STREAM" == "1" ]
  then
  # Processing Starts
  createStream "$PLAYLIST_NAME" "$OUT_NAME" "$BITRATE" &
  PID=$!
  PIDS=(${PIDS[@]} $PID)
  BITRATE_PROCESSES=(${BITRATE_PROCESSES[@]} $br)
  else
  createStream "$PLAYLIST_NAME" "$OUT_NAME" "$BITRATE"
  fi
  # Will deal with exit statuses shortly.
  #|| exit 1
   
  done
   
  if [ "$NO_FORK" == "0" ] && [ ! "$LIVE_STREAM" == "1" ]
  then
  # Monitor the background tasks for completion
  echo "All transcoding processes started, awaiting completion"
  awaitCompletion
  fi
   
  else
   
  # No bitrate specified
   
  # Finally, lets build the output filename format
  OUT_NAME="${INPUTFILENAME}_%05d.ts"
  PLAYLIST_NAME="$OUTPUT_DIRECTORY/${PLAYLIST_PREFIX}.m3u8"
   
  echo "Generating HLS segments - this may take some time"
   
  # Processing Starts
   
  createStream "$PLAYLIST_NAME" "$OUT_NAME" "$BITRATE"
   
   
  fi
file:a/README.md -> file:b/README.md
HLS-Stream-Creator HLS-Stream-Creator
================== ==================
   
Introduction Introduction
------------- -------------
   
HLS-Stream-Creator is a simple BASH Script designed to take a media file, segment it and create an M3U8 playlist for serving using HLS. HLS-Stream-Creator is a simple BASH Script designed to take a media file, segment it and create an M3U8 playlist for serving using HLS.
There are numerous tools out there which are far better suited to the task, and offer many more options. This project only exists because I was asked to look There are numerous tools out there which are far better suited to the task, and offer many more options. This project only exists because I was asked to look
into HTTP Live Streaming in depth, so after reading the [IETF Draft](http://tools.ietf.org/html/draft-pantos-http-live-streaming-11 "HLS on IETF") I figured I'd start with the basics by creating a script to encode arbitrary video into a VOD style HLS feed. into HTTP Live Streaming in depth, so after reading the [IETF Draft](http://tools.ietf.org/html/draft-pantos-http-live-streaming-11 "HLS on IETF") I figured I'd start with the basics by creating a script to encode arbitrary video into a VOD style HLS feed.
   
   
   
Usage Usage
------ ------
   
Usage is incredibly simple Usage is incredibly simple
   
``` ```
./HLS-Stream-Creator.sh inputfile segmentlength(seconds) [outputdir='./output'] ./HLS-Stream-Creator.sh -[l] [-c segmentcount] -i [inputfile] -s [segmentlength(seconds)] -o [outputdir]
   
   
  Deprecated Legacy usage:
  HLS-Stream-Creator.sh inputfile segmentlength(seconds) [outputdir='./output']
   
``` ```
   
So to split a video file called *example.avi* into segments of 10 seconds, we'd run So to split a video file called *example.avi* into segments of 10 seconds, we'd run
   
``` ```
./HLS-Stream-Creator.sh example.avi 10 ./HLS-Stream-Creator.sh -i example.avi -s 10
  ```
   
  **Arguments**
   
  ```
  -i [file] Input file
  -s [s] Segment length (seconds)
  -o [directory] Output directory (default: ./output)
  -c [count] Number of segments to include in playlist (live streams only) - 0 is no limit
  -l Input is a live stream
   
``` ```
   
   
   
Output Output
------- -------
   
As of version 1, the HLS resources will be output to the directory *output*. These will consist of video segments encoded in H.264 with AAC audio and an m3u8 file in the format As of version 1, the HLS resources will be output to the directory *output*. These will consist of video segments encoded in H.264 with AAC audio and an m3u8 file in the format
   
>\#EXTM3U >\#EXTM3U
>\#EXT-X-MEDIA-SEQUENCE:0 >\#EXT-X-MEDIA-SEQUENCE:0
>\#EXT-X-VERSION:3 >\#EXT-X-VERSION:3
>\#EXT-X-TARGETDURATION:10 >\#EXT-X-TARGETDURATION:10
>\#EXTINF:10, no desc >\#EXTINF:10, no desc
>example_00001.ts >example_00001.ts
>\#EXTINF:10, no desc >\#EXTINF:10, no desc
>example_00002.ts >example_00002.ts
>\#EXTINF:10, no desc >\#EXTINF:10, no desc
>example_00003.ts >example_00003.ts
>\#EXTINF:5, no desc >\#EXTINF:5, no desc
>example_00004.ts >example_00004.ts
>\#EXT-X-ENDLIST >\#EXT-X-ENDLIST
   
   
   
Using a Specific FFMPEG binary Using a Specific FFMPEG binary
------------------------------- -------------------------------
   
There may be occasions where you don't want to use the *ffmpeg* that appears in PATH. At the top of the script, the ffmpeg command is defined, so change this to suit your needs There may be occasions where you don't want to use the *ffmpeg* that appears in PATH. At the top of the script, the ffmpeg command is defined, so change this to suit your needs
   
``` ```
FFMPEG='/path/to/different/ffmpeg' FFMPEG='/path/to/different/ffmpeg'
``` ```
   
   
Additional Environment Variables Additional Environment Variables
------------------------------- -------------------------------
   
There are few environment variables which can control the ffmpeg behaviour. There are few environment variables which can control the ffmpeg behaviour.
   
* `VIDEO_CODEC` - The encoder which will be used by ffmpeg for video streams. Examples: _libx264_, _nvenc_ * `VIDEO_CODEC` - The encoder which will be used by ffmpeg for video streams. Examples: _libx264_, _nvenc_
* `AUDIO_CODEC` - Encoder for the audio streams. Examples: _aac_, _libfdk_acc_, _mp3_, _libfaac_ * `AUDIO_CODEC` - Encoder for the audio streams. Examples: _aac_, _libfdk_acc_, _mp3_, _libfaac_
* `NUMTHREADS` - A number which will be passed to the `-threads` argument of ffmpeg. Newer ffmpegs with modern libx264 encoders will use the optimal number of threads by default. * `NUMTHREADS` - A number which will be passed to the `-threads` argument of ffmpeg. Newer ffmpegs with modern libx264 encoders will use the optimal number of threads by default.
* `FFMPEG_FLAGS` - Additional flags for ffmpeg. They will be passed without any modification. * `FFMPEG_FLAGS` - Additional flags for ffmpeg. They will be passed without any modification.
   
Example usage: Example usage:
   
``` ```
export VIDEO_CODEC="nvenc" export VIDEO_CODEC="nvenc"
export FFMPEG_FLAGS="-pix_fmt yuv420p -profile:v" export FFMPEG_FLAGS="-pix_fmt yuv420p -profile:v"
./HLS-Stream-Creator.sh example.avi 10 ./HLS-Stream-Creator.sh example.avi 10
``` ```
   
License License
-------- --------
   
HLS-Stream-Creator is licensed under the [BSD 3 Clause License](http://opensource.org/licenses/BSD-3-Clause) and is Copyright (C) 2013 [Ben Tasker](http://www.bentasker.co.uk) HLS-Stream-Creator is licensed under the [BSD 3 Clause License](http://opensource.org/licenses/BSD-3-Clause) and is Copyright (C) 2013 [Ben Tasker](http://www.bentasker.co.uk)
   
   
Issue Tracking Issue Tracking
---------------- ----------------
   
Although the Github issue tracker can be used, the bulk of project management (such as it is) happens in JIRA. See [projects.bentasker.co.uk](http://projects.bentasker.co.uk/jira_projects/browse/HLS.html) for a HTML mirror of the tracking. Although the Github issue tracker can be used, the bulk of project management (such as it is) happens in JIRA. See [projects.bentasker.co.uk](http://projects.bentasker.co.uk/jira_projects/browse/HLS.html) for a HTML mirror of the tracking.